/* ------------------------------------------------------------ */
/*
HTTrack, Offline Browser for Windows and Unix
Copyright (C) Xavier Roche & Yann Philippot

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.


Important notes:

- We hereby ask people using this source NOT to use it in purpose of grabbing
emails addresses, or collecting any other private informations on persons.
This would disgrace our work, and spoil the many hours we spent on it.


This project has been developed by Xavier Roche and Yann Philippot,
and originally supervised by Daniel Carr and Patrick Ducrot.
Developed at "ISMRA - Ensi Caen", computing department
(Engineering School of Caen - France, http://www.ismra.fr)
*/


/* ------------------------------------------------------------ */
/* File: httrack.c subroutines:                                 */
/*       cache system (index and stores files in cache)         */
/* ------------------------------------------------------------ */



#ifndef HTSCACHE_DEFH
#define HTSCACHE_DEFH 

#include "httrack.h"

// cache
void cache_add(htsblk r,char* url_adr,char* url_fil,char* url_save,FILE* cache_ndx,FILE* cache_dat,int all_in_cache);
htsblk cache_read(httrackp* opt,cache_back cache,char* adr,char* fil,char* save);
htsblk* cache_header(httrackp* opt,cache_back cache,char* adr,char* fil);
void cache_init(cache_back* cache,httrackp* opt);

int cache_wstr(FILE* fp,char* s);
void cache_rstr(FILE* fp,char* s);
int  cache_brstr(char* adr,char* s);
int cache_brint(char* adr,int* i);
void cache_rint(FILE* fp,int* i);
int cache_wint(FILE* fp,int i);
#endif
