/* ------------------------------------------------------------ */
/*
HTTrack, Offline Browser for Windows and Unix
Copyright (C) Xavier Roche & Yann Philippot

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.


Important notes:

- We hereby ask people using this source NOT to use it in purpose of grabbing
emails addresses, or collecting any other private informations on persons.
This would disgrace our work, and spoil the many hours we spent on it.


This project has been developed by Xavier Roche and Yann Philippot,
and originally supervised by Daniel Carr and Patrick Ducrot.
Developed at "ISMRA - Ensi Caen", computing department
(Engineering School of Caen - France, http://www.ismra.fr)
*/


/* ------------------------------------------------------------ */
/* File: httrack.c subroutines:                                 */
/*       command-line help system                               */
/* ------------------------------------------------------------ */

#include "htshelp.h"
#include "htsmain.h"
#include "htscatchurl.h"

#define waitkey if (more) { char s[4]; printf("\nMORE.. q to quit\n"); linput(stdin,s,4); if (strcmp(s,"q")==0) quit=1; else printf("Page %d\n\n",++m); }
void infomsg(char* msg) {
  static int l=0;
  static m=0;
  static more=0;
  static int quit=0;
  if (msg==NULL)
    quit=0;
  if (msg) {
    if (!quit) {
      if (strlen(msg)==1) {
        if (msg[0]=='1') {
          more=1;
          return;
        }
      }
      printf("%s\n",msg);
      l++;
      if (l>20) {
        l=0;
        waitkey;
      }
    }
  }
}
#if HTS_ANALYSTE!=2
void help_wizard() {
  char urls[1024];
  char mainpath[256]="";
  char projname[256]="";
  char stropt[1024]="-";    // options
  char stropt2[1024]="";    // options longues
  char strwild[1024]="";    // wildcards
  //
  char str[256];
  char* a;
  
  printf("\n");
  printf("Welcome to HTTrack Offline Browser "HTTRACK_VERSION"\n");
  printf("Copyright (C) Xavier Roche & Yann Philippot\n");
#ifdef HTTRACK_AFF_WARNING
  printf("NOTE: "HTTRACK_AFF_WARNING"\n");
#endif
#ifdef HTS_PLATEFORM_NAME
  printf("[compiled: "HTS_PLATEFORM_NAME"]\n");
#endif
  printf("To see the option list, enter a blank line or try httrack --help\n");
  //
  // Project name
  while(strlen(projname)==0) {
    printf("\n");
    printf("Enter project name :");
    fflush(stdout);
    linput(stdin,projname,250);
    if (strlen(projname)==0)
      help("httrack",1);
  }
  //
  // Path
  printf("\nBase path (return=current directory) :");
  linput(stdin,str,250);
  if (strlen(str))
    if ((str[strlen(str)-1]!='/') && (str[strlen(str)-1]!='\\'))
      strcat(str,"/");
  strcat(stropt2,"-O \""); strcat(stropt2,str); strcat(stropt2,projname); strcat(stropt2,"\" ");
  // Crer si ce n'est fait un index.html 1er niveau
  make_empty_index(str);
  //
  printf("\n");
  printf("Enter URLs (separated by commas or blank spaces) :");
  fflush(stdout);
  linput(stdin,urls,250);
  if (strlen(urls)>0) {
    while(a=strchr(urls,',')) *a=' ';
    while(a=strchr(urls,'\t')) *a=' ';
    
    // Action
    printf("\nAction:\n");
    switch(help_query("Mirror Web Site(s)|Mirror Web Site(s) with Wizard|Just Get Files Indicated|Mirror ALL links in URLs (Multiple Mirror)|Test Links In URLs (Bookmark Test)|Update/Continue a Mirror",1)) {
    case 1: break; 
    case 2: strcat(stropt,"W"); break;
    case 3: strcat(stropt2,"--get "); break;
    case 4: strcat(stropt2,"--mirrorlinks "); break;
    case 5: strcat(stropt2,"--testlinks "); break;
    case 6: strcat(stropt2,"--update "); break;
    case 0: return; break;
    }
      
    // Proxy
    printf("\nProxy (return=none) :");
    linput(stdin,str,250);
    if (strlen(str)) {
      while(a=strchr(str,' ')) *a=':';    // port
      if (!strchr(jump_identification(str),':')) {
        char str2[256];
        printf("\nProxy port (return=8080) :");
        linput(stdin,str2,250);
        strcat(str,":");
        if (strlen(str2)==0)
          strcat(str,"8080");
        else
          strcat(str,str2);
      }
      strcat(stropt2,"-P "); strcat(stropt2,str); strcat(stropt2," ");
    }
    
    // Wildcards
    printf("\nYou can define wildcards, like: -*.gif +www.*.com/*.zip -*img_*.zip\n");
    printf("Wildcards (return=none) :");
    linput(stdin,strwild,250);
    
    // Options
    do {
      printf("\nYou can define additional options, such as recurse level (r<number>), separed by blank spaces\n");
      printf("To see the option list, type help\n");
      printf("Additional options (return=none) :");
      linput(stdin,str,250);
      if (strfield2(str,"help")) {
        help("httrack",2);
      } else if (strlen(str)) {
        strcat(stropt,str);
      }
    } while(strfield2(str,"help"));
    
    {
      char cmd[1024];
      char *argv[256];
      int argc=1;
      int g=0;
      int i=0;
      //
      printf("\n");
      if (strlen(stropt)==1)
        stropt[0]='\0';    // aucune
      sprintf(cmd,"%s %s %s %s",urls,stropt,stropt2,strwild);
      printf("---> Wizard command line: httrack %s\n\n",cmd);
      printf("Ready to launch the mirror? (Y/n) :");
      fflush(stdout);
      linput(stdin,str,250);
      if (strlen(str)) {
        if (!((str[0]=='y') || (str[0]=='Y')))
          exit(0);
      }
      printf("\n");

      // couper en morceaux
      argv[0]="winhttrack";
      argv[1]=cmd;
      argc++;    
      while(cmd[i])  {
        if(cmd[i]=='\"') g=!g;
        if(cmd[i]==' '){
          if(!g){
            cmd[i]='\0';
            argv[argc++]=cmd+i+1;
          }
        }  
        i++;
      }
      main(argc,argv);
    }
  //} else {
  //  help("httrack",1);
  }
}
int help_query(char* list,int def) {
  char s[256];
  char* a;
  int opt;
  int n=1;
  a=list;
  while(strlen(a)) {
    char* b = strchr(a,'|');
    if (b) {
      char str[256]="";
      strncat(str,a,(int) b - (int) a);
      if (n==def)
        printf("(enter)\t%d\t%s\n",n++,str);
      else
        printf("\t%d\t%s\n",n++,str);
      a=b+1;
    } else
      a=list+strlen(list);
  }
  printf("\t0\tQuit");
  do {
    printf("\n: ");
    fflush(stdout);
    linput(stdin,s,250);
  } while ((strlen(s)!=0) && (sscanf(s,"%d",&opt)!=1));
  if (strlen(s))
    return opt;
  else
    return def;
}
#endif

// Capture d'URL
void help_catchurl(char* dest_path) {
  char adr_prox[1024];
  int port_prox;
  T_SOC soc=catch_url_init_std(&port_prox,adr_prox);
  if (soc!=INVALID_SOCKET) {
    char url[1024]="";
    char method[32]="";
    char data[32768]="";
    //
    printf("Okay, temporary proxy installed.\nSet your browser's preferences to:\n\n");
    printf("\tProxy's address: \t%s\n\tProxy's port: \t%d\n",adr_prox,port_prox);
    //
    if (catch_url(soc,url,method,data)) {
      char dest[1024];
      int i=0;
      do {
        sprintf(dest,"%s%s%d",dest_path,"hts-post",i);
        i++;
      } while(fexist(dest));
      {
        FILE* fp=fopen(dest,"wb");
        if (fp) {
          fwrite(data,strlen(data),1,fp);
          fclose(fp);
        }
      }
      // former URL!
      {
        char finalurl[1024];
        escape_http(dest);
        sprintf(finalurl,"%s"POSTTOK"file:%s",url,dest);
        printf("\nThe URL is: \"%s\"\n",finalurl);
      }
    } else
      printf("Unable to analyse the URL\n");
  } else
    printf("Unable to create a temporary proxy (no remaining port)\n");
}

// Crer un index.html vide
void make_empty_index(char* str) {
#if 0
  if (!fexist(fconcat(str,"index.html"))) {
    FILE* fp=fopen(fconcat(str,"index.html"),"wb");
    if (fp) {
      fprintf(fp,"<!-- "HTS_TOPINDEX" -->"CRLF);
      fprintf(fp,"<HTML><BODY>Index is empty!<BR>(File used to index all HTTrack projects)</BODY></HTML>"CRLF);
      fclose(fp);
    }
  }
#endif
}

// mini-aide  (h: help)
//           y
void help(char* app,int more) {
  infomsg("");
  if (more)
    infomsg("1");
  if (more != 2) {
    char info[1024];
    infomsg("HTTrack version "HTTRACK_VERSION" (compiled "__DATE__")");
#ifdef HTTRACK_AFF_WARNING
    infomsg("NOTE: "HTTRACK_AFF_WARNING);
#endif
    sprintf(info,"\tusage: %s <URLs> [-option] [+<FILTERs>] [-<FILTERs>]",app);
    infomsg(info);
    infomsg("\twith options listed below: (* is the default value)");
    infomsg("");
  }
  infomsg("General options:");
  infomsg("  O  path for mirror/logfiles+cache (-O path_mirror[,path_cache_and_logfiles])");
  infomsg("");
  infomsg("Action options:");
  infomsg("  w *mirror web sites");
  infomsg("  W  mirror web sites, semi-automatic (asks questions)");
  infomsg("  g  just get files (saved in the current directory)");
  infomsg("  i  continue an interrupted mirror using the cache");
  infomsg("  Y   mirror ALL links located in the first level pages (mirror links)");
  infomsg("");
  infomsg("Proxy options:");
  infomsg("  P  proxy use (-P proxy:port or -P user:pass@proxy:port)");
  infomsg(" %f *use proxy for ftp (f0 don't use)");
  infomsg("");
  infomsg("Limits options:");
  infomsg("  rN set the mirror depth to N");
  infomsg("  mN maximum file length for a non-html file");
  infomsg("  mN,N'                  for non html (N) and html (N')");
  infomsg("  MN maximum overall size that can be uploaded/scanned");
  infomsg("  EN maximum mirror time in seconds (60=1 minute, 3600=1 hour)");
  infomsg("  AN maximum transfer rate in bytes/seconds (1000=1kb/s max)");
  infomsg("  GN pause transfer if N bytes reached, and wait until lock file is deleted");
  infomsg("");
  infomsg("Flow control:");
  infomsg("  cN number of multiple connections (*c8)");
  infomsg("  TN timeout, number of seconds after a non-responding link is shutdown");
  infomsg("  RN number of retries, in case of timeout or non-fatal errors (*R1)");
  infomsg("  JN traffic jam control, minimum transfert rate (bytes/seconds) tolerated for a link");
  infomsg("  HN host is abandonned if: 0=never, 1=timeout, 2=slow, 3=timeout or slow");
  infomsg("");
  infomsg("Links options:");
  infomsg(" %P *extended parsing, attempt to parse all links, even in unknown tags or Javascript (%P0 don't use)");
  infomsg("  n   get non-html files 'near' an html file (ex: an image located outside)");
  infomsg("  t   test all URLs (even forbidden ones)");
  infomsg("");
  infomsg("Build options:");
  infomsg("  NN  name conversion type (0 *original structure 1,2,3 html/data in one directory,..)");
  infomsg("  N   user defined structure (-N \"%h%p/%n.%t\")");
  infomsg("  LN  long names (L1 *long names / L0 8-3 conversion)");
  infomsg("  K   keep original links (e.g. http://www.adr/link) (K0 *relative link)");
  infomsg("  x   replace external html links by error pages");
  infomsg("  o *generate output html file in case of error (404..) (o0 don't generate)");
  infomsg("  X *purge old files after update (X0 keep delete)");
  infomsg("");
  infomsg("Spider options:");
  infomsg("  bN  accept cookies in cookies.txt (0=do not accept,* 1=accept)");
  infomsg("  u check document type if unknown (cgi,asp..) (u0 don't check, * u1 check but /, u2 check always)");
  infomsg("  j *parse Java Classes (j0 don't parse)");
  infomsg("  sN  follow robots.txt and meta robots tags (0=never,1=sometimes,* 2=always)");
  infomsg(" %B  tolerant requests (avoid bugs on some servers, but not standard)");
  infomsg("");
  infomsg("Browser ID:");
  infomsg("  F  user-agent field (-F \"user-agent name\")");
  infomsg(" %F  footer string in Html code (-%F \"Mirrored [from host %s [file %s [at %s]]]\"");
  infomsg("");
  infomsg("Log, index, cache");
  infomsg("  C  create/use a cache for updates and retries (C0 no cache,C1 cache is prioritary,* C2 test update before)");
  infomsg("  k  store all files in cache (not useful if files on disk)");
  infomsg(" %n  do not re-download locally erased files");
  infomsg("  Q  log quiet mode (no log)");
  infomsg("  q  quiet mode (no questions)");
  infomsg("  z  extra infos log");
  infomsg("  Z  debug log");
  infomsg("  v  verbose screen mode");
  infomsg("  f *log file mode");
  infomsg("  I *make an index (I0 don't make)");
  infomsg("");
  infomsg("Expert options:");
  infomsg("  pN priority mode: (* p3)");
  infomsg("      0 just scan, don't save anything (for checking links)");
  infomsg("      1 save only html files");
  infomsg("      2 save only non html files");
  infomsg("     *3 save all files");
  infomsg("      7 get html files before, then treat other files");
  infomsg("  S   stay on the same directory");
  infomsg("  D  *can only go down into subdirs");    
  infomsg("  U   can only go to upper directories");
  infomsg("  B   can both go up&down into the directory structure");
  infomsg("  a  *stay on the same address");
  infomsg("  d   stay on the same principal domain");
  infomsg("  l   stay on the same location (.com, etc.)");
  infomsg("  e   go everywhere on the web");
  infomsg(" %H  debug HTTP headers in logfile");
  infomsg("");
  infomsg("Command-line specific options:");
  infomsg("  V execute system command after each files ($0 is the filename: -V \"rm \\$0\")");
  infomsg("");
  infomsg("");
  infomsg("Shortcuts:");
  infomsg("--mirror      <URLs> *make a mirror of site(s) (default)");
  infomsg("--get         <URLs>  get the files indicated, do not seek other URLs (-qg)");
  infomsg("--mirrorlinks <URLs>  test links in pages (-Y)");
  infomsg("--testlinks   <URLs>  test links in pages (-r1p0C0I0t)");
  infomsg("--spider      <URLs>  spider site(s), to test links: reports Errors & Warnings (-p0C0I0t)");
  infomsg("--testsite    <URLs>  identical to --spider");
  infomsg("--skeleton    <URLs>  make a mirror, but gets only html files (-p1)");
  infomsg("--update              update a mirror, without confirmation (-iC2)");
  infomsg("--continue            continue a mirror, without confirmation (-iC1)");
  infomsg("");
  infomsg("--catchurl            create a temporary proxy to capture an URL or a form post URL");
  infomsg("--clean               erase cache & log files");
  infomsg("");
  infomsg("--http10              force http/1.0 requests when possible (-%B)");
  infomsg("");
  infomsg("");
  infomsg("example: httrack www.someweb.com/bob/");
  infomsg("means:   mirror site www.someweb.com/bob/ and only this site");
  infomsg("");
  infomsg("example: httrack www.someweb.com/bob/ www.anothertest.com/mike/");
  infomsg("means:   mirror the two sites together (with shared links)");
  infomsg("");
  infomsg("example: httrack www.someweb.com/bob/bobby.html +*/* -r6");
  infomsg("means get all files starting from bobby.html, with 6 link-depth, and possibility of going everywhere on the web");
  infomsg("");
  infomsg("example: httrack www.someweb.com/bob/bobby.html --spider -P proxy.myhost.com:8080");
  infomsg("runs the spider on www.someweb.com/bob/bobby.html using a proxy");
  infomsg("");
  infomsg("HTTrack version "HTTRACK_VERSION" (compiled "__DATE__")");
  infomsg("Copyright (C) Xavier Roche & Yann Philippot from Ensi Caen, France (www.ismra.fr)");
#ifdef HTS_PLATEFORM_NAME
  infomsg("[compiled: "HTS_PLATEFORM_NAME"]");
#endif
  infomsg(NULL);

//  infomsg("  R  *relative links (e.g ../link)\n");
//  infomsg("  A   absolute links (e.g /www.adr/link)\n");
}


