/* ------------------------------------------------------------ */
/*
HTTrack, Offline Browser for Windows and Unix
Copyright (C) Xavier Roche & Yann Philippot

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.


Important notes:

- We hereby ask people using this source NOT to use it in purpose of grabbing
emails addresses, or collecting any other private informations on persons.
This would disgrace our work, and spoil the many hours we spent on it.


This project has been developed by Xavier Roche and Yann Philippot,
and originally supervised by Daniel Carr and Patrick Ducrot.
Developed at "ISMRA - Ensi Caen", computing department
(Engineering School of Caen - France, http://www.ismra.fr)
*/


/* ------------------------------------------------------------ */
/* File: Java classes parser                                    */
/* ------------------------------------------------------------ */


// htsjava.c - Parseur de classes java

#include "stdio.h"
#include "htsjava.h"
#include "htssystem.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
//#include <math.h>

#if HTS_PLATEFORM==1
#define PLAT 1        // 0 UNIX 1 DOS
#else
#define PLAT 0        // 0 UNIX 1 DOS
#endif

// ** HTS_xx sinon pas pris par VC++
#define HTS_CLASS  7
#define HTS_FIELDREF  9
#define HTS_METHODREF  10
#define HTS_STRING  8
#define HTS_INTEGER  3
#define HTS_FLOAT  4
#define HTS_LONG  5
#define HTS_DOUBLE  6
#define HTS_INTERFACE  11
#define HTS_NAMEANDTYPE  12
#define HTS_ASCIZ  1
#define HTS_UNICODE  2

#define JAVADEBUG 0

int hts_parse_java(char *file,char* err_msg)
{
  FILE *fpout;
  HEADER header;
  OBJET *tab;
  
#if JAVADEBUG
  printf("fopen\n");
#endif
  if ((fpout = fopen(fconv(file), "rb")) == NULL)
  {
    //fprintf(stderr, "Cannot open input file.\n");
    sprintf(err_msg,"Unable to open file %s",file);
    return 0;   // une erreur..
  }
    
#if JAVADEBUG
  printf("fread\n");
#endif
  //if (fread(&header,1,sizeof(HEADER),fpout) != sizeof(HEADER)) {   // pas complet..
  if (fread(&header,1,10,fpout) != 10) {   // pas complet..
    fclose(fpout);
    sprintf(err_msg,"File header too small (file len = %d)",fsize(file));
    return 0;
  }

#if JAVADEBUG
  printf("header\n");
#endif
  // tester en tte
#if PLAT ==1
  header.magic= swap(header.magic,4);
  header.count =  swap(header.count,2); 
  if(header.magic!=0xCAFEBABE) {
    sprintf(err_msg,"non java file");
    return 0;
  }
#else
  if(header.magic!=0xCAFEBABE){
    sprintf(err_msg,"non java file");
    return 0;
  }
#endif        
    
  tab =(OBJET*)calloct(header.count,sizeof(OBJET));
  if (!tab) {
    sprintf(err_msg,"Unable to alloc %d bytes",sizeof(OBJET));
    fclose(fpout);
    return 0;    // erreur..
  }

#if JAVADEBUG
  printf("calchead\n");
#endif
  {
    int i;
    
    for (i = 1; i < header.count; i++) {
      int err=0;  // ++    
      tab[i]=readtable(fpout,tab[i],&err,err_msg);
      if (!err) {
        if ((tab[i].type == HTS_LONG) ||(tab[i].type == HTS_DOUBLE)) i++;  //2 element si double ou float
      } else {    // ++ une erreur est survenue!
        if (strlen(err_msg)==0)
          strcpy(err_msg,"Internal readtable error");
        freet(tab);
        fclose(fpout);
        return 0;
      }
    }
    
  }

  
#if JAVADEBUG
  printf("addfiles\n");
#endif
  {
    int acess = readshort(fpout);
    int Class = readshort(fpout);
    int SClass = readshort(fpout);
    int i;

    for (i = 1; i <header.count; i++) {

      if (tab[i].type == HTS_CLASS) {
        
        if ((tab[i].index1<header.count) && (tab[i].index1>=0)) {

        
        if((tab[i].index1!=SClass) && (tab[i].index1!=Class) && (tab[tab[i].index1].name[0]!='[')) {

          if(!strstr(tab[tab[i].index1].name,"java/")) {
            char tempo[1024]="";
	       
            sprintf(tempo,"%s.class",tab[tab[i].index1].name);
#if JAVADEBUG
  printf("add %s\n",tempo);
#endif
            hts_add_file(tempo);
          }
          
      }
      } else { 
        i=header.count;  // exit 
      }
      }
      
    }
  }
  
 
#if JAVADEBUG
  printf("end\n");
#endif
  freet(tab);
  fclose(fpout);
  return 1;
  
}




// error: !=0 si erreur fatale
OBJET readtable(FILE *fp,OBJET trans,int* error,char* err_msg)
{
  short int length;
  int j;
  *error = 0;  // pas d'erreur
  trans.type = fgetc(fp);
  switch (trans.type) {
    
    
  case HTS_CLASS:
    strcpy(trans.name,"Class");
    trans.index1 = readshort(fp);
    break;
    
  case HTS_FIELDREF:
    strcpy(trans.name,"Field Reference");
    trans.index1 = readshort(fp);
    readshort(fp);
    break;
    
  case HTS_METHODREF:
    strcpy(trans.name,"Method Reference");
    trans.index1 = readshort(fp);
    readshort(fp);
    break;
    
  case HTS_INTERFACE:
    strcpy(trans.name,"Interface Method Reference");
    trans.index1 =readshort(fp);
    readshort(fp);
    break;
  case HTS_NAMEANDTYPE:
    strcpy(trans.name,"Name and Type");
    trans.index1 = readshort(fp);
    readshort(fp);
    break;
    
  case HTS_STRING:
    strcpy(trans.name,"String");
    trans.index1 = readshort(fp);
    
    break;
    
  case HTS_INTEGER:
    strcpy(trans.name,"Integer");
    for(j=0;j<4;j++) fgetc(fp);
    break;
    
  case HTS_FLOAT:
    strcpy(trans.name,"Float");
    for(j=0;j<4;j++) fgetc(fp);
    break;
    
  case HTS_LONG:
    strcpy(trans.name,"Long");
    for(j=0;j<8;j++) fgetc(fp);
    break;
  case HTS_DOUBLE:
    strcpy(trans.name,"Double");
    for(j=0;j<8;j++) fgetc(fp);
    break;
    
  case HTS_ASCIZ:
  case HTS_UNICODE:
    
    if (trans.type == HTS_ASCIZ)
      strcpy(trans.name,"HTS_ASCIZ");
    else
      strcpy(trans.name,"HTS_UNICODE");
    
    {
      char buffer[1024]; 
      char *p;
      
      p=&buffer[0];
      length = readshort(fp);
      if (length<500) {
        // while ((length > 0) && (length<500)) {
        while (length > 0) {
          *p++ =fgetc(fp);
          
          length--;
        }
        *p='\0';
        
        //#if JDEBUG
        //      if(tris(buffer)==1) printf("%s\n ",buffer);
        //      if(tris(buffer)==2)  printf("%s\n ",printname(buffer));
        //#endif
        if(tris(buffer)==1)  hts_add_file(buffer);       
        if(tris(buffer)==2)  hts_add_file(printname(buffer));
               
        strcpy(trans.name,buffer);
      } else {    // gros pb
        sprintf(err_msg,"Internal stucture length too big (%d)",length);
        *error = 1;
        return(trans);
      }
    }
    break;
  default:
    // printf("Type inconnue\n");
    // on arrte tout 
    sprintf(err_msg,"Internal structure unknown (%d)",trans.type);
    *error = 1;
    return(trans);
    break;
  }  
  return(trans);
}






short int readshort(FILE *fp)
{
  // ** short int i;
  typedef struct sint{
    short int val;
  }SHINT; 
  
  SHINT valint;
  fread(&valint,sizeof(valint),1,fp);
  
#if PLAT == 0   
  return valint.val;
#endif
#if PLAT == 1
  return swap(valint.val,2);
#endif
  
}

// a^b
double my_pow(double a,double b) {
  double r=1;
  int i;
  for(i=0;i<b;i++)
    r*=a;
  return r;
}

unsigned int swap(long int nomber,int digit)
{
  long unsigned  int t,i;
  long unsigned int d=0xff;
  double total=0;
  for(i=0;i<(long unsigned  int) digit;i++){ // **
    t=nomber & d;
    total=total+t*my_pow((double)16,(double)(digit*2-i*2-2));
    nomber=nomber >> 8;
  }
  return (int)total;
}


int tris(char * buffer)
{
  //
  // Java
  if((buffer[0]=='[') && buffer[1]=='L' && !strstr(buffer,"java/")) 
    return 2;
  if (strstr(buffer,".gif") || strstr(buffer,".jpg") || strstr(buffer,".jpeg") || strstr(buffer,".au") ) 
    return 1;
  // Ajouts R.X: test type
  // Autres fichiers
  {
    char type[256]="";
    get_httptype(type,buffer,0);
    if (strlen(type))     // type reconnu!
      return 1;
  }
  return 0;
}


char * printname(char  name[1024])
{
  static char rname[1024];
  //char *rname;
  char *p;
  char *p1;
  int j;
  
  p=&name[0];
  
  if(*p!='[')  return "";
  p+=2;
  //rname=(char*)calloct(strlen(name)+8,sizeof(char));
  p1=rname;
  for (j = 0; j < (int) strlen(name); j++,p++) {
    if (*p == '/') *p1='.'; 
    if (*p==';'){*p1='\0';
    strcat(rname,".class");
    return (rname);}
    else *p1=*p;
    p1++;
  }
  p1-=3;
  *p1='\0';
  return (rname);
  
}
